/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_Manager.h"
#include "com_phidget22_ManagerBase.h"

static jclass manager_class;
jfieldID manager_handle_fid;

static jclass attachEvent_class;
static jmethodID fireAttach_mid	;
static jmethodID attachEvent_cons;
static jfieldID nativeAttachHandler_fid;

static jclass detachEvent_class;
static jmethodID fireDetach_mid	;
static jmethodID detachEvent_cons;
static jfieldID nativeDetachHandler_fid;

void com_phidget22_ManagerBase_OnLoad(JNIEnv *env) {
	if (!(manager_class = (*env)->FindClass(env, "com/phidget22/ManagerBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ManagerBase");
	if (!(manager_class = (jclass)(*env)->NewGlobalRef(env, manager_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef manager_class");
	if (!(manager_handle_fid = (*env)->GetFieldID(env, manager_class, "handle", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID handle from manager_class");

	if (!(attachEvent_class = (*env)->FindClass(env, "com/phidget22/ManagerAttachEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ManagerAttachEvent");
	if (!(attachEvent_class = (jclass)(*env)->NewGlobalRef(env, attachEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref AttachEvent_class");
	if (!(fireAttach_mid = (*env)->GetMethodID(env, manager_class, "fireAttach", "(Lcom/phidget22/ManagerAttachEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireAttach");
	if (!(attachEvent_cons = (*env)->GetMethodID(env, attachEvent_class, "<init>", "(Lcom/phidget22/Manager;Lcom/phidget22/Phidget;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from AttachEvent_class");
	if (!(nativeAttachHandler_fid = (*env)->GetFieldID(env, manager_class, "nativeAttachHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeAttachHandler from manager_class");

	if (!(detachEvent_class = (*env)->FindClass(env, "com/phidget22/ManagerDetachEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ManagerDetachEvent");
	if (!(detachEvent_class = (jclass)(*env)->NewGlobalRef(env, detachEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref DetachEvent_class");
	if (!(fireDetach_mid = (*env)->GetMethodID(env, manager_class, "fireDetach", "(Lcom/phidget22/ManagerDetachEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireDetach");
	if (!(detachEvent_cons = (*env)->GetMethodID(env, detachEvent_class, "<init>", "(Lcom/phidget22/Manager;Lcom/phidget22/Phidget;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from DetachEvent_class");
	if (!(nativeDetachHandler_fid = (*env)->GetFieldID(env, manager_class, "nativeDetachHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeDetachHandler from manager_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_ManagerBase_create(JNIEnv * env, jclass obj) {
	PhidgetManagerHandle phid;
	int error; 
	if ((error = PhidgetManager_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_ManagerBase_close(JNIEnv * env, jobject obj) {
	PhidgetManagerHandle h = (PhidgetManagerHandle)(uintptr_t)(*env)->GetLongField(env, obj, manager_handle_fid);
	int error;
	if ((error = PhidgetManager_close(h)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_ManagerBase_open(JNIEnv * env, jobject obj) {
	PhidgetManagerHandle h = (PhidgetManagerHandle)(uintptr_t)(*env)->GetLongField(env, obj, manager_handle_fid);
	int error;
	if ((error = PhidgetManager_open(h)))
		PH_THROW(error);
}

static void CCONV attach_handler(PhidgetManagerHandle h, void *arg, PhidgetHandle channel) {
	Phidget_ChannelClass cclass;
	jclass pcls;
	jmethodID pcons;
	jobject attachEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	if (Phidget_getChannelClass(channel, &cclass) != EPHIDGET_OK)
		return;

	switch (cclass) {
	case PHIDCHCLASS_VOLTAGERATIOINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/VoltageRatioInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DIGITALINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DigitalInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DIGITALOUTPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DigitalOutput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_RCSERVO:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/RCServo")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_VOLTAGEOUTPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/VoltageOutput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_ACCELEROMETER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Accelerometer")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_VOLTAGEINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/VoltageInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_CAPACITIVETOUCH:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/CapacitiveTouch")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_RFID:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/RFID")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_GPS:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/GPS")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_GYROSCOPE:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Gyroscope")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_MAGNETOMETER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Magnetometer")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_SPATIAL:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Spatial")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_TEMPERATURESENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/TemperatureSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_ENCODER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Encoder")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_FREQUENCYCOUNTER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/FrequencyCounter")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_IR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/IR")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_PHSENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/PHSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DCMOTOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DCMotor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_CURRENTINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/CurrentInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_STEPPER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Stepper")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_LCD:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/LCD")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DATAADAPTER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DataAdapter")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_MOTORPOSITIONCONTROLLER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/MotorPositionController")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_BLDCMOTOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/BLDCMotor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DISTANCESENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DistanceSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_HUMIDITYSENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/HumiditySensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_LIGHTSENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/LightSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_PRESSURESENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/PressureSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_POWERGUARD:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/PowerGuard")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_SOUNDSENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/SoundSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_RESISTANCEINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/ResistanceInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_HUB:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Hub")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_MESHDONGLE:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/MeshDongle")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_FIRMWAREUPGRADE:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/FirmwareUpgrade")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_GENERIC:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Generic")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DICTIONARY:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Dictionary")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	default:
		return;
	}

	if (!(attachEv = (*env)->NewObject(env, attachEvent_class, attachEvent_cons, obj, (*env)->NewObject(env, pcls, pcons, channel))))
		return;

	Phidget_retain(channel);
	(*env)->CallVoidMethod(env, obj, fireAttach_mid, attachEv);
	(*env)->DeleteLocalRef(env, attachEv);
}

JNIEXPORT void JNICALL Java_com_phidget22_ManagerBase_enableAttachEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeAttachHandler_fid, b);
	PhidgetManagerHandle h = (PhidgetManagerHandle)( uintptr_t)(*env)->GetLongField(env, obj, manager_handle_fid);
	PhidgetManager_setOnAttachHandler(h, b ? attach_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV detach_handler(PhidgetManagerHandle h, void *arg, PhidgetHandle channel) {
	Phidget_ChannelClass cclass;
	jclass pcls;
	jmethodID pcons;
	jobject detachEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	if (Phidget_getChannelClass(channel, &cclass) != EPHIDGET_OK)
		return;

	switch (cclass) {
	case PHIDCHCLASS_VOLTAGERATIOINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/VoltageRatioInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DIGITALINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DigitalInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DIGITALOUTPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DigitalOutput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_RCSERVO:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/RCServo")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_VOLTAGEOUTPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/VoltageOutput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_ACCELEROMETER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Accelerometer")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_VOLTAGEINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/VoltageInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_CAPACITIVETOUCH:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/CapacitiveTouch")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_RFID:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/RFID")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_GPS:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/GPS")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_GYROSCOPE:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Gyroscope")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_MAGNETOMETER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Magnetometer")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_SPATIAL:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Spatial")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_TEMPERATURESENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/TemperatureSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_ENCODER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Encoder")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_FREQUENCYCOUNTER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/FrequencyCounter")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_IR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/IR")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_PHSENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/PHSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DCMOTOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DCMotor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_CURRENTINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/CurrentInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_STEPPER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Stepper")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_LCD:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/LCD")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DATAADAPTER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DataAdapter")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_MOTORPOSITIONCONTROLLER:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/MotorPositionController")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_BLDCMOTOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/BLDCMotor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DISTANCESENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/DistanceSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_HUMIDITYSENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/HumiditySensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_LIGHTSENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/LightSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_PRESSURESENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/PressureSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_POWERGUARD:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/PowerGuard")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_SOUNDSENSOR:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/SoundSensor")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_RESISTANCEINPUT:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/ResistanceInput")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_HUB:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Hub")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_MESHDONGLE:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/MeshDongle")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_FIRMWAREUPGRADE:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/FirmwareUpgrade")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_GENERIC:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Generic")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	case PHIDCHCLASS_DICTIONARY:
		if (!(pcls = (*env)->FindClass(env, "com/phidget22/Dictionary")))
			return;
		if (!(pcons = (*env)->GetMethodID(env, pcls, "<init>", "(J)V")))
			return;
		break;
	default:
		return;
	}

	if (!(detachEv = (*env)->NewObject(env, detachEvent_class, detachEvent_cons, obj, (*env)->NewObject(env, pcls, pcons, channel))))
		return;

	Phidget_retain(channel);
	(*env)->CallVoidMethod(env, obj, fireDetach_mid, detachEv);
	(*env)->DeleteLocalRef(env, detachEv);
}

JNIEXPORT void JNICALL Java_com_phidget22_ManagerBase_enableDetachEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeDetachHandler_fid, b);
	PhidgetManagerHandle h = (PhidgetManagerHandle)( uintptr_t)(*env)->GetLongField(env, obj, manager_handle_fid);
	PhidgetManager_setOnDetachHandler(h, b ? detach_handler : NULL, (void *)(uintptr_t) gr);
}
