/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_MotorPositionController.h"
#include "com_phidget22_MotorPositionControllerBase.h"

static jclass motorPositionController_class;
extern jfieldID phidget_handle_fid;

static jclass positionChangeEvent_class;
static jmethodID firePositionChange_mid	;
static jmethodID positionChangeEvent_cons;
static jfieldID nativePositionChangeHandler_fid;

static jclass dutyCycleUpdateEvent_class;
static jmethodID fireDutyCycleUpdate_mid	;
static jmethodID dutyCycleUpdateEvent_cons;
static jfieldID nativeDutyCycleUpdateHandler_fid;

void com_phidget22_MotorPositionControllerBase_OnLoad(JNIEnv *env) {
	if (!(motorPositionController_class = (*env)->FindClass(env, "com/phidget22/MotorPositionControllerBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MotorPositionControllerBase");
	if (!(motorPositionController_class = (jclass)(*env)->NewGlobalRef(env, motorPositionController_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef motorPositionController_class");

	if (!(positionChangeEvent_class = (*env)->FindClass(env, "com/phidget22/MotorPositionControllerPositionChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MotorPositionControllerPositionChangeEvent");
	if (!(positionChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, positionChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref PositionChangeEvent_class");
	if (!(firePositionChange_mid = (*env)->GetMethodID(env, motorPositionController_class, "firePositionChange", "(Lcom/phidget22/MotorPositionControllerPositionChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID firePositionChange");
	if (!(positionChangeEvent_cons = (*env)->GetMethodID(env, positionChangeEvent_class, "<init>", "(Lcom/phidget22/MotorPositionController;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from PositionChangeEvent_class");
	if (!(nativePositionChangeHandler_fid = (*env)->GetFieldID(env, motorPositionController_class, "nativePositionChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativePositionChangeHandler from motorPositionController_class");

	if (!(dutyCycleUpdateEvent_class = (*env)->FindClass(env, "com/phidget22/MotorPositionControllerDutyCycleUpdateEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MotorPositionControllerDutyCycleUpdateEvent");
	if (!(dutyCycleUpdateEvent_class = (jclass)(*env)->NewGlobalRef(env, dutyCycleUpdateEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref DutyCycleUpdateEvent_class");
	if (!(fireDutyCycleUpdate_mid = (*env)->GetMethodID(env, motorPositionController_class, "fireDutyCycleUpdate", "(Lcom/phidget22/MotorPositionControllerDutyCycleUpdateEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireDutyCycleUpdate");
	if (!(dutyCycleUpdateEvent_cons = (*env)->GetMethodID(env, dutyCycleUpdateEvent_class, "<init>", "(Lcom/phidget22/MotorPositionController;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from DutyCycleUpdateEvent_class");
	if (!(nativeDutyCycleUpdateHandler_fid = (*env)->GetFieldID(env, motorPositionController_class, "nativeDutyCycleUpdateHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeDutyCycleUpdateHandler from motorPositionController_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_MotorPositionControllerBase_create(JNIEnv * env, jclass obj) {
	PhidgetMotorPositionControllerHandle phid;
	int error; 
	if ((error = PhidgetMotorPositionController_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getAcceleration(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double acceleration;
	if ((error = PhidgetMotorPositionController_getAcceleration(h, &acceleration)))
		PH_THROW(error);
	return acceleration;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setAcceleration(JNIEnv * env, jobject obj, jdouble acceleration) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setAcceleration(h, (double)acceleration)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinAcceleration(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minAcceleration;
	if ((error = PhidgetMotorPositionController_getMinAcceleration(h, &minAcceleration)))
		PH_THROW(error);
	return minAcceleration;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxAcceleration(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxAcceleration;
	if ((error = PhidgetMotorPositionController_getMaxAcceleration(h, &maxAcceleration)))
		PH_THROW(error);
	return maxAcceleration;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double currentLimit;
	if ((error = PhidgetMotorPositionController_getCurrentLimit(h, &currentLimit)))
		PH_THROW(error);
	return currentLimit;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setCurrentLimit(JNIEnv * env, jobject obj, jdouble currentLimit) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setCurrentLimit(h, (double)currentLimit)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minCurrentLimit;
	if ((error = PhidgetMotorPositionController_getMinCurrentLimit(h, &minCurrentLimit)))
		PH_THROW(error);
	return minCurrentLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxCurrentLimit;
	if ((error = PhidgetMotorPositionController_getMaxCurrentLimit(h, &maxCurrentLimit)))
		PH_THROW(error);
	return maxCurrentLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getCurrentRegulatorGain(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double currentRegulatorGain;
	if ((error = PhidgetMotorPositionController_getCurrentRegulatorGain(h, &currentRegulatorGain)))
		PH_THROW(error);
	return currentRegulatorGain;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setCurrentRegulatorGain(JNIEnv * env, jobject obj, jdouble currentRegulatorGain) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setCurrentRegulatorGain(h, (double)currentRegulatorGain)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinCurrentRegulatorGain(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minCurrentRegulatorGain;
	if ((error = PhidgetMotorPositionController_getMinCurrentRegulatorGain(h, &minCurrentRegulatorGain)))
		PH_THROW(error);
	return minCurrentRegulatorGain;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxCurrentRegulatorGain(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxCurrentRegulatorGain;
	if ((error = PhidgetMotorPositionController_getMaxCurrentRegulatorGain(h, &maxCurrentRegulatorGain)))
		PH_THROW(error);
	return maxCurrentRegulatorGain;
}

JNIEXPORT jint JNICALL Java_com_phidget22_MotorPositionControllerBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t dataInterval;
	if ((error = PhidgetMotorPositionController_getDataInterval(h, &dataInterval)))
		PH_THROW(error);
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setDataInterval(h, (uint32_t)dataInterval)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDataInterval;
	if ((error = PhidgetMotorPositionController_getMinDataInterval(h, &minDataInterval)))
		PH_THROW(error);
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDataInterval;
	if ((error = PhidgetMotorPositionController_getMaxDataInterval(h, &maxDataInterval)))
		PH_THROW(error);
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getDeadBand(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double deadBand;
	if ((error = PhidgetMotorPositionController_getDeadBand(h, &deadBand)))
		PH_THROW(error);
	return deadBand;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setDeadBand(JNIEnv * env, jobject obj, jdouble deadBand) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setDeadBand(h, (double)deadBand)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getDutyCycle(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double dutyCycle;
	if ((error = PhidgetMotorPositionController_getDutyCycle(h, &dutyCycle)))
		PH_THROW(error);
	return dutyCycle;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_MotorPositionControllerBase_getEngaged(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int engaged;
	if ((error = PhidgetMotorPositionController_getEngaged(h, &engaged)))
		PH_THROW(error);
	return engaged;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setEngaged(JNIEnv * env, jobject obj, jboolean engaged) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setEngaged(h, (int)engaged)))
		PH_THROW(error);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_MotorPositionControllerBase_getFanMode(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	Phidget_FanMode fanMode;
	if ((error = PhidgetMotorPositionController_getFanMode(h, &fanMode)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, FanMode_class, FanMode_getEnum_mid, fanMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setFanMode(JNIEnv * env, jobject obj, jobject fanMode) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setFanMode(h, (Phidget_FanMode)(*env)->CallIntMethod(env, fanMode, FanMode_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_MotorPositionControllerBase_getIOMode(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	Phidget_EncoderIOMode IOMode;
	if ((error = PhidgetMotorPositionController_getIOMode(h, &IOMode)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, EncoderIOMode_class, EncoderIOMode_getEnum_mid, IOMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setIOMode(JNIEnv * env, jobject obj, jobject IOMode) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setIOMode(h, (Phidget_EncoderIOMode)(*env)->CallIntMethod(env, IOMode, EncoderIOMode_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getKd(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double kd;
	if ((error = PhidgetMotorPositionController_getKd(h, &kd)))
		PH_THROW(error);
	return kd;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setKd(JNIEnv * env, jobject obj, jdouble kd) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setKd(h, (double)kd)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getKi(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double ki;
	if ((error = PhidgetMotorPositionController_getKi(h, &ki)))
		PH_THROW(error);
	return ki;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setKi(JNIEnv * env, jobject obj, jdouble ki) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setKi(h, (double)ki)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getKp(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double kp;
	if ((error = PhidgetMotorPositionController_getKp(h, &kp)))
		PH_THROW(error);
	return kp;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setKp(JNIEnv * env, jobject obj, jdouble kp) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setKp(h, (double)kp)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getPosition(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double position;
	if ((error = PhidgetMotorPositionController_getPosition(h, &position)))
		PH_THROW(error);
	return position;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinPosition(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minPosition;
	if ((error = PhidgetMotorPositionController_getMinPosition(h, &minPosition)))
		PH_THROW(error);
	return minPosition;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxPosition(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxPosition;
	if ((error = PhidgetMotorPositionController_getMaxPosition(h, &maxPosition)))
		PH_THROW(error);
	return maxPosition;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_addPositionOffset(JNIEnv * env, jobject obj, jdouble positionOffset) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_addPositionOffset(h, (double)positionOffset)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getRescaleFactor(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double rescaleFactor;
	if ((error = PhidgetMotorPositionController_getRescaleFactor(h, &rescaleFactor)))
		PH_THROW(error);
	return rescaleFactor;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setRescaleFactor(JNIEnv * env, jobject obj, jdouble rescaleFactor) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setRescaleFactor(h, (double)rescaleFactor)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getStallVelocity(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double stallVelocity;
	if ((error = PhidgetMotorPositionController_getStallVelocity(h, &stallVelocity)))
		PH_THROW(error);
	return stallVelocity;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setStallVelocity(JNIEnv * env, jobject obj, jdouble stallVelocity) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setStallVelocity(h, (double)stallVelocity)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinStallVelocity(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minStallVelocity;
	if ((error = PhidgetMotorPositionController_getMinStallVelocity(h, &minStallVelocity)))
		PH_THROW(error);
	return minStallVelocity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxStallVelocity(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxStallVelocity;
	if ((error = PhidgetMotorPositionController_getMaxStallVelocity(h, &maxStallVelocity)))
		PH_THROW(error);
	return maxStallVelocity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getTargetPosition(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double targetPosition;
	if ((error = PhidgetMotorPositionController_getTargetPosition(h, &targetPosition)))
		PH_THROW(error);
	return targetPosition;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setTargetPosition__DLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jdouble targetPosition, jobject asyncHandler) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetMotorPositionController_setTargetPosition_async(h, (double)targetPosition, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setTargetPosition__D(JNIEnv * env, jobject obj, jdouble targetPosition) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setTargetPosition(h, (double)targetPosition)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getVelocityLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double velocityLimit;
	if ((error = PhidgetMotorPositionController_getVelocityLimit(h, &velocityLimit)))
		PH_THROW(error);
	return velocityLimit;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setVelocityLimit(JNIEnv * env, jobject obj, jdouble velocityLimit) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetMotorPositionController_setVelocityLimit(h, (double)velocityLimit)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinVelocityLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minVelocityLimit;
	if ((error = PhidgetMotorPositionController_getMinVelocityLimit(h, &minVelocityLimit)))
		PH_THROW(error);
	return minVelocityLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxVelocityLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxVelocityLimit;
	if ((error = PhidgetMotorPositionController_getMaxVelocityLimit(h, &maxVelocityLimit)))
		PH_THROW(error);
	return maxVelocityLimit;
}

static void CCONV dutyCycleUpdate_handler(PhidgetMotorPositionControllerHandle h, void *arg, double dutyCycle) {
	jobject dutyCycleUpdateEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((dutyCycleUpdateEv = (*env)->NewObject(env, dutyCycleUpdateEvent_class, dutyCycleUpdateEvent_cons, obj, dutyCycle)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireDutyCycleUpdate_mid, dutyCycleUpdateEv);
		(*env)->DeleteLocalRef(env, dutyCycleUpdateEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_enableDutyCycleUpdateEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeDutyCycleUpdateHandler_fid, b);
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetMotorPositionController_setOnDutyCycleUpdateHandler(h, b ? dutyCycleUpdate_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV positionChange_handler(PhidgetMotorPositionControllerHandle h, void *arg, double position) {
	jobject positionChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((positionChangeEv = (*env)->NewObject(env, positionChangeEvent_class, positionChangeEvent_cons, obj, position)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePositionChange_mid, positionChangeEv);
		(*env)->DeleteLocalRef(env, positionChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_enablePositionChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativePositionChangeHandler_fid, b);
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetMotorPositionController_setOnPositionChangeHandler(h, b ? positionChange_handler : NULL, (void *)(uintptr_t) gr);
}
