/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_RFID.h"
#include "com_phidget22_RFIDBase.h"

static jclass RFID_class;
extern jfieldID phidget_handle_fid;

static jclass tagEvent_class;
static jmethodID fireTag_mid	;
static jmethodID tagEvent_cons;
static jfieldID nativeTagHandler_fid;

static jclass tagLostEvent_class;
static jmethodID fireTagLost_mid	;
static jmethodID tagLostEvent_cons;
static jfieldID nativeTagLostHandler_fid;

void com_phidget22_RFIDBase_OnLoad(JNIEnv *env) {
	if (!(RFID_class = (*env)->FindClass(env, "com/phidget22/RFIDBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RFIDBase");
	if (!(RFID_class = (jclass)(*env)->NewGlobalRef(env, RFID_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef RFID_class");

	if (!(tagEvent_class = (*env)->FindClass(env, "com/phidget22/RFIDTagEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RFIDTagEvent");
	if (!(tagEvent_class = (jclass)(*env)->NewGlobalRef(env, tagEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref TagEvent_class");
	if (!(fireTag_mid = (*env)->GetMethodID(env, RFID_class, "fireTag", "(Lcom/phidget22/RFIDTagEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireTag");
	if (!(tagEvent_cons = (*env)->GetMethodID(env, tagEvent_class, "<init>", "(Lcom/phidget22/RFID;Ljava/lang/String;Lcom/phidget22/RFIDProtocol;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from TagEvent_class");
	if (!(nativeTagHandler_fid = (*env)->GetFieldID(env, RFID_class, "nativeTagHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeTagHandler from RFID_class");

	if (!(tagLostEvent_class = (*env)->FindClass(env, "com/phidget22/RFIDTagLostEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RFIDTagLostEvent");
	if (!(tagLostEvent_class = (jclass)(*env)->NewGlobalRef(env, tagLostEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref TagLostEvent_class");
	if (!(fireTagLost_mid = (*env)->GetMethodID(env, RFID_class, "fireTagLost", "(Lcom/phidget22/RFIDTagLostEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireTagLost");
	if (!(tagLostEvent_cons = (*env)->GetMethodID(env, tagLostEvent_class, "<init>", "(Lcom/phidget22/RFID;Ljava/lang/String;Lcom/phidget22/RFIDProtocol;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from TagLostEvent_class");
	if (!(nativeTagLostHandler_fid = (*env)->GetFieldID(env, RFID_class, "nativeTagLostHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeTagLostHandler from RFID_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_RFIDBase_create(JNIEnv * env, jclass obj) {
	PhidgetRFIDHandle phid;
	int error; 
	if ((error = PhidgetRFID_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_RFIDBase_getAntennaEnabled(JNIEnv * env, jobject obj) {
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int antennaEnabled;
	if ((error = PhidgetRFID_getAntennaEnabled(h, &antennaEnabled)))
		PH_THROW(error);
	return antennaEnabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_RFIDBase_setAntennaEnabled(JNIEnv * env, jobject obj, jboolean antennaEnabled) {
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetRFID_setAntennaEnabled(h, (int)antennaEnabled)))
		PH_THROW(error);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_RFIDBase_getTagPresent(JNIEnv * env, jobject obj) {
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int tagPresent;
	if ((error = PhidgetRFID_getTagPresent(h, &tagPresent)))
		PH_THROW(error);
	return tagPresent;
}

JNIEXPORT void JNICALL Java_com_phidget22_RFIDBase_write(JNIEnv * env, jobject obj, jstring tagString, jobject protocol, jboolean lockTag) {
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetRFID_write(h, (const char *)(tagString == NULL ? NULL : (*env)->GetStringUTFChars(env, tagString, NULL)), (PhidgetRFID_Protocol)(*env)->CallIntMethod(env, protocol, RFIDProtocol_getCode_mid), (int)lockTag)))
		PH_THROW(error);
}

static void CCONV tag_handler(PhidgetRFIDHandle h, void *arg, const char * tag, PhidgetRFID_Protocol protocol) {
	jobject tagEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((tagEv = (*env)->NewObject(env, tagEvent_class, tagEvent_cons, obj, (*env)->NewStringUTF(env, tag), (*env)->CallStaticObjectMethod(env, RFIDProtocol_class, RFIDProtocol_getEnum_mid, protocol))) != 0) {
		(*env)->CallVoidMethod(env, obj, fireTag_mid, tagEv);
		(*env)->DeleteLocalRef(env, tagEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_RFIDBase_enableTagEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeTagHandler_fid, b);
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetRFID_setOnTagHandler(h, b ? tag_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV tagLost_handler(PhidgetRFIDHandle h, void *arg, const char * tag, PhidgetRFID_Protocol protocol) {
	jobject tagLostEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((tagLostEv = (*env)->NewObject(env, tagLostEvent_class, tagLostEvent_cons, obj, (*env)->NewStringUTF(env, tag), (*env)->CallStaticObjectMethod(env, RFIDProtocol_class, RFIDProtocol_getEnum_mid, protocol))) != 0) {
		(*env)->CallVoidMethod(env, obj, fireTagLost_mid, tagLostEv);
		(*env)->DeleteLocalRef(env, tagLostEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_RFIDBase_enableTagLostEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeTagLostHandler_fid, b);
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetRFID_setOnTagLostHandler(h, b ? tagLost_handler : NULL, (void *)(uintptr_t) gr);
}
